package org.borutt.db;

import java.util.List;

/**
 * Data access object interface with CRUD and common operations on a persistent
 * data repository for a particular entity.
 *
 * @param <K> Entity key type.
 * @param <E> Entity type.
 */
public interface Dao<K, E> {

    /**
     * Persists the the given entity instance in the repository. The entity instance
     * must not contain a key. A unique entity key (in the scope of the repository)
     * is generated by the repository. Method returns the provided entity instance
     * with the generated key.
     * 
     * @param e Provided entity to be persisted.
     * @return Provided entity with a generated key.
     */
    public E create(E e);

    /**
     * Updates a corresponding persisted repository entity with the provided entity.
     * Returns an entity instance corresponding to the updated persisted entity.
     * 
     * @param e Provided entity for update.
     * @return Entity corresponding to the updated persisted entity.
     */
    public E update(E e);

    /**
     * Deletes the persisted entity.
     * 
     * @param id A key that identifies a persisted entity to be deleted.
     */
    public void delete(K id);

    /**
     * Finds and returns an entity instance for the given key.s
     * 
     * @param id Entity lookup key.
     * @return Found entity or null if not found.
     */
    public E find(K id);

    /**
     * Returns all persisted entity instances. The number of actually returned
     * instances may be limited by a specific repository or system-wide restriction.
     */
    public List<E> findAll();

    /**
     * Returns persisted entities in the provided range to support result list
     * paging. The page range is defined as a pair of lower bound and upper bound
     * indices indexing the repository resultset elements prior to paging. The first
     * element of the repository resultset prior to paging is regarded as index
     * zero. The upper boundary index limits the page size if the repository
     * resultset contains elements beyond the upper boundary index. Lower boundary
     * is inclusive, upper boundary is exclusive.
     * 
     * @param minIdx Lower boundary element index of the page range.
     * @param maxIdx Upper boundary element index of the page range.
     * @return A list of entity instances within the provided page range, including
     *         the entity with the lower boundary index and excluding the entity
     *         with the upper bound index.
     */
    public List<E> findRange(int minIdx, int maxIdx);

}
